#ifndef MMC_DEFS_H_
#define MMC_DEFS_H_

#include "file.h"
#include "fat.h"
#include "command.h"
#include "mmc.h"

#define F_CPU 16000000

#define nop()  __asm__ __volatile__ ("nop" ::)

// UART: include statement + method names  
#include "uart.h"
#define MMC_UART_INIT			uinit
#define MMC_UART_PUTC			uputc
#define MMC_UART_PUTS			uputs
#define MMC_UART_GETC			ugetc
#define MMC_UART_GETS			ugets

// SD-CARD SPI: include statement + method names  
#include "mmc.h"
#define MMC_SPI_INIT			mmc_spi_init
#define MMC_SPI_ENABLE			mmc_spi_enable
#define MMC_SPI_MAX_SPEED		mmc_spi_max_speed
#define MMC_SPI_READ_BYTE		mmc_read_byte
#define MMC_SPI_WRITE_BYTE		mmc_write_byte


// SPI HARDWARE: port and pins for SD-SPI 
  #define MMC_Write  		PORTB	//Port an der die MMC/SD-Karte angeschlossen ist also des SPI 
  #define MMC_Read 			PINB
  #define MMC_Direction_REG	DDRB	

  #if defined (__AVR_ATmega128__)
	#define SPI_DI    		3  //Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO    		2  //Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock  		1  //Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select 4  //Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS    		0  //Nicht Benutz mu� aber definiert werden
  #endif

  #if defined (__AVR_ATmega32__)
	#define SPI_DI   		6  //Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO    		5  //Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock  		7  //Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select 3  //Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS    		4  //Nicht Benutz mu� aber definiert werden
  #endif

  #if defined (__AVR_ATmega168__)
	#define SPI_DI   		4  //Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO    		3  //Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock  		5  //Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select 1  //Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS    		2  //Nicht Benutz mu� aber definiert werden
  #endif

  #if defined (__AVR_ATmega644__)
	#define SPI_DI   		6  //Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO    		5  //Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock  		7  //Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select 1  //Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS			4  //Nicht Benutz mu� aber definiert werden
  #endif

  #if defined (__AVR_ATmega8__)
	#define SPI_DI    		4  //Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO    		3  //Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock  		5  //Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select 1  //Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS    		2  //Nicht Benutz mu� aber definiert werden
  #endif

#endif /*MMC_DEFS_H_*/
